local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local BaikUnitFrame = BaikCore.BaikUnitFrame
local Database = BaikCore.Database
local Log = BaikCore.Log
local Option = BaikCore.Option
local VertexColor = BaikCore.VertexColor

local OrderNumber = BaikUnitFrame.OrderNumber

-- Add Module
local Art = BaikUnitFrame:NewModule("Art", "AceHook-3.0")

-- Constants
local DB_PREFIX = "unit_art"
local OPTION_NAME = "unit_art_style"
local ARTS = {
    PlayerFrameTexture,
    TargetFrameTextureFrameTexture,
    FocusFrameTextureFrameTexture,
    PetFrameTexture,
    PartyMemberFrame1Texture,
    PartyMemberFrame2Texture,
    PartyMemberFrame3Texture,
    PartyMemberFrame4Texture,
    Boss1TargetFrameTextureFrameTexture,
    Boss2TargetFrameTextureFrameTexture,
    Boss3TargetFrameTextureFrameTexture,
    Boss4TargetFrameTextureFrameTexture,
    Boss5TargetFrameTextureFrameTexture,
}

local function ColorFrames()
    VertexColor:ColorFrameAll(ARTS, DB_PREFIX)
end

local function HeaderOpt()
    return {
        name = "Art Options",
        type = "header",
        order = OrderNumber:GetNext(),
    }
end

-- Ace3 Callbacks
function Art:OnInitialize()
    Log:v("Art_OnInitialize")
    VertexColor:InitDb(DB_PREFIX)
    BaikUnitFrame:AddOption("art_header", HeaderOpt())

    -- VertexColor does multiple layouts
    VertexColor:InsertOpts(BaikUnitFrame:GetOptionArgs(), DB_PREFIX, ColorFrames,
                           OrderNumber)
end

function Art:OnEnable()
    Log:v("Art_OnEnable")
    ColorFrames()
end

function Art:OnDisable()
    Log:v("Art_OnDisable")
end
